-------------------------------------------------------
-- 4bit x 5 to 1 select and 20bit all
-- 2006/6/21
-------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity sel5to1a_and_20bit is
	port(
		sel0	:in std_logic;
		sel1	:in std_logic;
		sel2	:in std_logic;
		sel3	:in std_logic;
		sel4	:in std_logic;
		a0		:in std_logic;
		b0		:in std_logic;
		c0		:in std_logic;
		d0		:in std_logic;
		a1		:in std_logic;
		b1		:in std_logic;
		c1		:in std_logic;
		d1		:in std_logic;
		a2		:in std_logic;
		b2		:in std_logic;
		c2		:in std_logic;
		d2		:in std_logic;
		a3		:in std_logic;
		b3		:in std_logic;
		c3		:in std_logic;
		d3		:in std_logic;
		a4		:in std_logic;
		b4		:in std_logic;
		c4		:in std_logic;
		d4		:in std_logic;
		outa	:out std_logic;
		outb	:out std_logic;
		outc	:out std_logic;
		outd	:out std_logic;
		outb0	:out std_logic;
		outb1	:out std_logic;
		outb2	:out std_logic;
		outb3	:out std_logic;
		outb4	:out std_logic;
		outb5	:out std_logic;
		outb6	:out std_logic;
		outb7	:out std_logic;
		outb8	:out std_logic;
		outb9	:out std_logic;
		outb10	:out std_logic;
		outb11	:out std_logic;
		outb12	:out std_logic;
		outb13	:out std_logic;
		outb14	:out std_logic;
		outb15	:out std_logic;
		outb16	:out std_logic;
		outb17	:out std_logic;
		outb18	:out std_logic;
		outb19	:out std_logic
		
		);
end sel5to1a_and_20bit;

architecture rtl of sel5to1a_and_20bit is
	signal input_t0		:std_logic_vector(3 downto 0);
	signal input_t1		:std_logic_vector(3 downto 0);
	signal input_t2		:std_logic_vector(3 downto 0);
	signal input_t3		:std_logic_vector(3 downto 0);
	signal input_t4		:std_logic_vector(3 downto 0);
	signal input_sel	:std_logic_vector(4 downto 0);
	signal output_table	:std_logic_vector(3 downto 0);
	signal output_bit	:std_logic_vector(19 downto 0);
	
begin
	input_t0 <= d0 & c0 & b0 & a0;
	input_t1 <= d1 & c1 & b1 & a1;
	input_t2 <= d2 & c2 & b2 & a2;
	input_t3 <= d3 & c3 & b3 & a3;
	input_t4 <= d4 & c4 & b4 & a4;
	input_sel <= sel4 & sel3 & sel2 & sel1 & sel0;
	
	output_bit <= input_t4 & input_t3 & input_t2 & input_t1 & input_t0;
	
	with input_sel select
		output_table <= input_t0 when "00001",	-- sel0
						input_t1 when "00010",	-- sel1
						input_t2 when "00100",	-- sel2
						input_t3 when "01000",	-- sel3
						input_t4 when "10000",	-- sel4
						"0000" when others;
						
	outa <= output_table(0);
	outb <= output_table(1);
	outc <= output_table(2);
	outd <= output_table(3);
	
	outb0 <= output_bit(0);
	outb1 <= output_bit(1);
	outb2 <= output_bit(2);
	outb3 <= output_bit(3);
	outb4 <= output_bit(4);
	outb5 <= output_bit(5);
	outb6 <= output_bit(6);
	outb7 <= output_bit(7);
	outb8 <= output_bit(8);
	outb9 <= output_bit(9);
	outb10 <= output_bit(10);
	outb11 <= output_bit(11);
	outb12 <= output_bit(12);
	outb13 <= output_bit(13);
	outb14 <= output_bit(14);
	outb15 <= output_bit(15);
	outb16 <= output_bit(16);
	outb17 <= output_bit(17);
	outb18 <= output_bit(18);
	outb19 <= output_bit(19);

end rtl;	
		